addpath('../');
% test
clear all;
close all;
n = 50;
d = 2;
x = randn(d,n);
y = ones(n,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = -1;

n = 1000;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1) = -1;


figure(1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');
%figure;


SD = simpleData(x,y);
%SD.kernelType = 'rbf';
%SD.kernelParam = [2];
SD.kernelType = 'tanh';
SD.kernelParam = [-0.8,-0.5];
%SD.kernelType = 'poly';
%SD.kernelParam = [3,0.01,1];
C=100000;
SM = simpleModelDNPSVM(SD,C);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
%SM.print2D();

% figure;
% C=1;
% SM = simpleModelDNPSVM(SD,C,SM.Il,SM.Iup,SM.Iun,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% figure;
% SD.clear();
% SD.kernelParam = [1,-1];
% SM = simpleModelDNPSVM(SD,C,SM.Il,SM.Iup,SM.Iun,SM.Iw);
% 
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% tic;
% valErr = SM.crossValError(3)
% toc
% 
% figure;
% C=[1000,1];
% SM = simpleModelDNPSVM(SD,C,SM.Il,SM.Iup,SM.Iun,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% 
% tic;
% valErr = SM.crossValError(3)
% toc
