addpath('../');
% test
clear;
close all;
%rand('seed',randseed(0))
n1 = 100;
d = 2;
x = randn(d,n1);
y = ones(n1,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n1)) = 2;
y(x(1,:)<0) = y(x(1,:)<0)+1;
y(x(2,:)<0) = y(x(2,:)<0)+2;


n = 2000;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1+0.1*randn(1,n)) = 2;
yt(xt(1,:)<0) = yt(xt(1,:)<0)+1;
yt(xt(2,:)<0) = yt(xt(2,:)<0)+2;


figure(1);
color = ['brgkmcy'];
for i=1:max(yt)
plot(xt(1,yt==i),xt(2,yt==i),['+',color(i)]);
hold on;
end

figure;

%Cmax = 1/max(length(y==i));


SD = simpleData(x,y);
SD.kernelType = 'rbf';
SD.kernelParam = [3];
Q = max(y);
C = 0.2;
lambda = 0.5;
%lambda = 0;
SM = simpleModelDocSVDD(SD,C,Q,lambda);
SM.kktgap=0.00000001;
tic;
SM.train;
toc
tic;
[ypred,pred,perf] = SM.test(xt,yt);
toc
disp(perf)
subplot(1,2,1);
SM.print2D;
%[~,pred] = max(ypred,[],2);
CM = confusionMatrix(yt,pred);


SD2 = simpleData(x,y);
SD2.kernelType = 'rbf';
SD2.kernelParam = SD.kernelParam;
%C = 1;
%lambda = 1/(Q);
SM2 = simpleModelDocSVM(SD2,C,Q,lambda);
SM2.kktgap = SM.kktgap;
tic;
SM2.train;
toc
tic;
[ypred2,perf] = SM2.test(xt,yt);
toc
disp(perf)
subplot(1,2,2);
SM2.print2D;
[~,pred2] = max(ypred2,[],2);
CM2 = confusionMatrix(yt,pred2);


% 
% 
% figure;
% C=Q/10;
% SM = simpleModelDocSVM(SD,C,Q,lambda,SM.Il,SM.Iu,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% figure;
% SD.clear();
% SD.kernelParam = 1;
% SM = simpleModelDocSVM(SD,C,Q,lambda,SM.Il,SM.Iu,SM.Iw);
% 
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% tic;
% valErr = SM.crossValError(10)
% toc
% 
% figure;
% C=Q./[100,100,10,1,50];
% SM = simpleModelDocSVM(SD,C,Q,lambda,SM.Il,SM.Iu,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% 
% tic;
% valErr = SM.crossValError(10)
% toc
% 
