% test USPS
clear;
close all;


load('../Data/usps.mat');
addpath('../');
SD = simpleData(train_patterns,train_labels);
SD.kernelType = 'poly';
%SD.kernelParam = 0.02;
SD.kernelParam = [5,10,4];
Q = max(train_labels);
%C = Q./100;
C = Q./(5*[20 10 50 30 40 60 20 30 20 40]);
lambda = 0.0001;%1/(2*Q);
%lambda = 0;
SM = simpleModelDocSVM(SD,C,Q,lambda);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(test_patterns,test_labels);
toc
disp(perf)

[~,pred] = max(ypred,[],2);
confusionMatrix(test_labels,pred);

