% test USPS
clear;
close all;


load('../Data/usps.mat');
addpath('../');
SD = simpleData(train_patterns,train_labels);
SD.kernelType = 'tanh';
%SD.kernelParam = 0.02;
SD.kernelParam = [-0.004,0.001];
C = 200;
SM = simpleModelENPSVM(SD,C,200);
tic;
SS = SM.train1vs1;
toc
tic;
[ypred,perf] = SM.test1vs1(SS,test_patterns,test_labels);
toc
disp(perf)
confusionMatrix(test_labels,ypred);

