addpath('../');
% test
clear all;
close all;
clc;
% n = 400;
% d = 2;
% x = randn(d,n);
% y = ones(n,1);
% y(x(1,:).^2+x(2,:).^2<1+0.2*randn(1,n)) = -1;
% 
% n2 = 10000;
% d = 2;
% xt = randn(d,n2);
% yt = ones(n2,1);
% yt(xt(1,:).^2+xt(2,:).^2<1) = -1;

n = 400;
n2 = 1000;
addpath('../../SVM-KM/');
[x,y,xt,yt]=datasets('checkers',n,n2,0);
x = x';
xt = xt';

figure(1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');
figure;


SD = simpleData(x,y);
SD.kernelType = 'tanh';
SD.kernelParam = [0.5,-0.2];
%SD.kernelType = 'rbf';
%SD.kernelParam = [0.5];

SD.getKernelValues(1:SD.n);
A=SD.kernelCache(1:SD.n,1:SD.n);

i = n-2;
[V,L] = eigs(A,[],i);
while abs(trace(L))<abs(0.9999*trace(A))
    i = i+1
    [V,L] = eigs(A,[],i);
end
figure(2);
plot(diag(L));
negs = find(diag(L)<0);
B = V*abs(L)*V';
SD = simpleData(B,y);
SD.trainvec = x;

%SD.kernelType = 'poly';
%SD.kernelParam = [3,0.01,1];
C=100;
SM = simpleModelCSVM(SD,C);
tic;
SM.train;
toc
% test sans revenir
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(1);
SM.print2D();

size(SM.alpha)
SM.alpha = V([SM.Iw,SM.Iu],:)'*(SM.alpha.*SM.SD.trainlab([SM.Iw,SM.Iu]));
size(SM.alpha)
SM.alpha(negs) = -SM.alpha(negs);
alpha = SM.alpha;
SM.alpha = (V*SM.alpha).*SM.SD.trainlab;
SM.SV = SM.SD.trainvec;
SM.Iw = 1:n;
SM.Iu = [];

% test en revenant dans l'espace de dpart
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(3);
SM.print2D();

SM.alpha = (V'\alpha).*SM.SD.trainlab;
SM.Iw = find(SM.alpha);
SM.alpha = SM.alpha(find(SM.alpha));
SM.SV = SM.SD.trainvec(:,SM.Iw);
beta = SM.alpha;
Iw = SM.Iw;

% test en revenant dans l'espace de dpart
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(7);
SM.print2D();

% en gardant les valeurs propres seulement
%SD.kernelCache(1:length(L),1:length(L)) = abs(L);
%SD.trainlab = V'*SD.trainlab;

%SM = simpleModelCSVM(SD,C);
%tic;
%SM.train;
%toc
[x,fval,exitflag,output,lambda]=quadprog(abs(L),-sum(V),[],[],SD.trainlab'*V,0,-abs(C*sum(V)),abs(C*sum(V)));

SM.alpha = V*x;
%alpha = SM.alpha;
SM.alpha = (SM.alpha).*SM.SD.trainlab;
SM.b = lambda.eqlin;
SM.Iw = find(SM.alpha);
SM.SV = SM.SD.trainvec(:,SM.Iw);

% test en revenant dans l'espace de dpart
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(5);
SM.print2D();

% test avec solution parcimonieuse?
SM.alpha = V'\x;
SM.alpha = (SM.alpha).*SM.SD.trainlab;
SM.Iw = find(SM.alpha);
SM.alpha = SM.alpha(find(SM.alpha));
SM.SV = SM.SD.trainvec(:,SM.Iw);
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(6);
SM.print2D();

[SM.alpha SM.alpha/(max(abs(SM.alpha))) beta/max(abs(beta)) beta]
[SM.Iw Iw]

