addpath('../');
% test
clear all;
close all;
n = 1000;
d = 2;
x = randn(d,n);
y = ones(n,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = -1;

n = 1000;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1) = -1;


figure(1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');
figure;


SD = simpleDataLS(x,y);
SD.kernelType = 'rbf';
SD.kernelParam = 2;
C=100;
SM = simpleModelCSVM(SD,C);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();

figure;
C=1000;
SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);

tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();


figure;
SD.clear();
SD.kernelParam = 1;
SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);


tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();

tic;
valErr = SM.crossValError(10)
toc

figure;
C=[1000,1];
SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);

tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();



tic;
valErr = SM.crossValError(10)
toc
