addpath('../');
% test
clear;
close all;
n = 1000;
d = 2;
x = randn(d,n);
y = ones(n,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = 2;
y(x(1,:)<0) = y(x(1,:)<0)+1;
y(x(2,:)<0) = y(x(2,:)<0)+2;


n = 1000;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1+0.1*randn(1,n)) = 2;
yt(xt(1,:)<0) = yt(xt(1,:)<0)+1;
yt(xt(2,:)<0) = yt(xt(2,:)<0)+2;


figure(1);
color = ['brgkmcy'];
for i=1:max(y)
plot(x(1,y==i),x(2,y==i),['+',color(i)]);
hold on;
end


SD = simpleData(x,y);
SD.kernelType = 'rbf';
SD.kernelParam = 2;
C=0.1;
SM = simpleModelNuSVM(SD,C);
tic;
SS = SM.train1vs1;
toc
tic;
[ypred,perf] = SM.test1vs1(SS,xt,yt);
toc
disp(perf)
SM.print2DMulti(SS);



C=0.2;
SM = simpleModelNuSVM(SD,C);
tic;
SS = SM.train1vs1(SS);
toc
tic;
[ypred,perf] = SM.test1vs1(SS,xt,yt);
toc
disp(perf)
SM.print2DMulti(SS);

SD.kernelParam = 0.8;
SM = simpleModelNuSVM(SD,C);
tic;
SS = SM.train1vs1(SS);
toc
tic;
[ypred,perf] = SM.test1vs1(SS,xt,yt);
toc
disp(perf)
SM.print2DMulti(SS);

