addpath('../');
% test
clear all;
close all;
% n = 50;
% d = 2;
% x = randn(d,n);
% y = ones(n,1);
% y(x(1,:).^2+x(2,:).^2<1+0*randn(1,n)) = -1;

napp = 200;
ntest = 2000;
%[x,y,xt,yt]=gdataset('clowns',napp,ntest,0.3);
[x,y,xt,yt]=gdataset('checkers',napp,ntest,-0.1);

% n = 1000;
% d = 2;
% xt = randn(d,n);
% yt = ones(n,1);
% yt(xt(1,:).^2+xt(2,:).^2<1) = -1;


figure(1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');
figure;


SD = simpleData(x,y);
SD.kernelType = 'tanh';
SD.kernelParam = [0.5,-0.1];
%SD.kernelType = 'rbf';
%SD.kernelParam = [0.7];
C=10000;
SM = simpleModelTSVM(SD,C);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();
[ypredapp,perfapp] = SM.test(x,y);
disp(perfapp)

figure;
subplot(3,1,1);
plot(SM.cout(1,:),'r');
subplot(3,1,2);
plot(sum(SM.cout(2:end,:)));

subplot(3,1,3);
plot(diag(SM.cout(2:end,:)'*SM.cout(2:end,:)));

% 
% figure;
% SM = simpleModelCSVM(SD,C);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% figure;
% SD.clear();
% SD.kernelParam = [3,5,1];
% SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);
% 
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% % tic;
% % valErr = SM.crossValError(10)
% % toc
% % 
% % figure;
% % C=[1000,1];
% % SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);
% % 
% % tic;
% % SM.train;
% % toc
% % tic;
% % [ypred,perf] = SM.test(xt,yt);
% % toc
% % disp(perf)
% % SM.print2D();
% % 
% % 
% % 
% % tic;
% % valErr = SM.crossValError(10)
% % toc
