addpath('../');
% test
clc;
clear all;
close all;
napp = 300;
ntest = 2000;
[x,y,xt,yt]=gdataset('checkers',napp,ntest,0.1);

figure(1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');
%figure;


SD = simpleData(x,y);
%SD.kernelType = 'rbf';
%SD.kernelParam = [3];
SD.kernelType = 'tanh';
SD.kernelParam = [0.1,0.01];
SD.getKernelValues(1:SD.n);
A = eig(0.5*SD.kernelCache(1:SD.n,1:SD.n)'+0.5*SD.kernelCache(1:SD.n,1:SD.n))
min(A)
max(A)
keyboard
%SD.kernelType = 'poly';
%SD.kernelParam = [3,0.01,1];
C=1000;
tic;
SM = simpleModelCSVM(SD,C);
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();

figure(2);
SD.clear;
tic;
SM2 = simpleModelENPSVM(SD,C,500);

SM2.train;
toc
tic;
[ypred,perf] = SM2.test(xt,yt);
toc
disp(perf)
SM2.print2D();

figure(3);

SD.clear;
tic;
SM3 = simpleModelENPSVM(SD,C,50);

SM3.train;
toc
tic;
[ypred,perf] = SM3.test(xt,yt);
toc
disp(perf)
SM3.print2D();
% 
% figure;
% 
% SM4 = simpleModelNP2SVM(SD,C);
% tic;
% SM4.train;
% toc
% 
% tic;
% [ypred,perf] = SM4.test(xt,yt);
% toc
% disp(perf)
% SM4.print2D();
% 
% figure;
% 
% SM4.b = -SM4.b;
% tic;
% [ypred,perf] = SM4.test(xt,yt);
% toc
% disp(perf)
% SM4.print2D();
% 
% figure;
% SM4.b = 0;
% tic;
% [ypred,perf] = SM4.test(xt,yt);
% toc
% disp(perf)
% SM4.print2D();

% figure(4);
% 
% SD.clear;
% tic;
% SM4 = simpleModelENPSVM(SD,C,250);
% 
% SM4.train;
% toc
% tic;
% [ypred,perf] = SM4.test(xt,yt);
% toc
% disp(perf)
% SM4.print2D();
% 
% figure(5);
% 
% SD.clear;
% tic;
% SM5 = simpleModelENPSVM(SD,C,500);
% 
% SM5.train;
% toc
% tic;
% [ypred,perf] = SM5.test(xt,yt);
% toc
% disp(perf)
% SM5.print2D();
% 
% 
% figure;
% SD.clear();
% SD.kernelParam = [1,-1];
% SM = simpleModelDNPSVM(SD,C,SM.Il,SM.Iup,SM.Iun,SM.Iw);
% 
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% tic;
% valErr = SM.crossValError(3)
% toc
% 
% figure;
% C=[1000,1];
% SM = simpleModelDNPSVM(SD,C,SM.Il,SM.Iup,SM.Iun,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% 
% tic;
% valErr = SM.crossValError(3)
% toc
