function CM = confusionMatrix(trueLabs,predLabs)

labsT = unique(trueLabs);
nbLabsT = length(labsT);
labsP = unique(predLabs);
nbLabsP = length(labsP);
CM = zeros(nbLabsT,nbLabsP);
for i=1:length(trueLabs)
        CM(labsT==trueLabs(i),labsP==predLabs(i)) = CM(labsT==trueLabs(i),labsP==predLabs(i))+1;
end

fprintf(' Pred : \t')
for j=1:nbLabsP
    fprintf('%d \t',labsP(j));
end
for i=1:nbLabsT
    fprintf('\n True : %d \t',labsT(i));
    for j=1:nbLabsP
        fprintf('%d \t',CM(i,j));
    end
end
fprintf('\n');
