addpath('../');
% test
clear all;
clc;
close all;
n = 100;
d = 2;
x = linspace(0,10,n);
y = cos(x)';

nt = 200;
xt = linspace(0,10,n);
yt = cos(xt)';


figure(1);
plot(x,y,'-ro');
figure;


disp('First learning');
SD = simpleData(x,y);
SD.kernelType = 'rbf';
SD.kernelParam = [10];
C=1000;
SM = simpleModelSVR(SD,C,0.1);
tic;

SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();


% figure;
% 
% disp('Change C, warm start and kernel cache');
% C=1000;
% SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% figure;
% SD.clear();
% disp('Change kernel param, warm start but kernel cache erased');
% SD.kernelParam = [.5];
% SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);
% 
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% figure;
% disp('change C, warm start, assymetric C (one per class)')
% C=[1000,10];
% SM = simpleModelCSVM(SD,C,SM.Il,SM.Iu,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% 
% tic;
% valErr = SM.crossValError(10)
% toc
