clear all;
close all;

napp = 300;
ntest = 2000;
[x,y,xt,yt]=gdataset('checkers',napp,ntest,0.1);
%load checkers2.mat


% SD = simpleData(x,y);
% SD.kernelType = 'tanh';
% SD.kernelParam = [-1,1.1];
%
% SD.getKernelValues(1:SD.n);
% K = SD.kernelCache(1:SD.n,1:SD.n);
% K = 0.5*K+0.5*K';
%
% min(eig(K))
%
% C = 100;
% SM = simpleModelDC(SD,C);
% SM.train;
% [ypred perf] = SM.test(xt,yt);
% perf
% %SM.print2D();


C = [0.5 1 5 10 50 100 500 1000 5000 10000];
p = [-2:0.2:2];
for i=1:length(p)
    for j=1:length(p)
        
        for k=1:length(C)
            clear SD;
            SD = simpleData(x,y);
            SD.kernelType = 'tanh';
            SD.kernelParam = [p(i),p(j)];
            SD.getKernelValues(1:SD.n);
            K = SD.kernelCache(1:SD.n,1:SD.n);
            K = 0.5*K+0.5*K';
            mineig(i,j) = min(eig(K));
            SM = simpleModelDC(SD,C(k));
            SM.train;
            [~, perf(i,j,k)] = SM.test(xt,yt);
            clear SM;
        end
        i
        j
        k
    end
end

mineig

bestperf = max(max(max(perf)))
ind = find(perf==bestperf,1);
[i,j,k] = ind2sub(size(perf),ind)


mineig(i,j)

clear SD;
SD = simpleData(x,y);
SD.kernelType = 'tanh';
SD.kernelParam = [p(i),p(j)];
SM = simpleModelDC(SD,C(k));
SM.train;
[~, perfMax] = SM.test(xt,yt)
figure;
SM.print2D;
clear SM;

perf(perf==0)=50;
worstperf = min(min(min(perf)))
indm = find(perf==worstperf,1)
[im,jm,km] = ind2sub(size(perf),indm)

clear SD;
SD = simpleData(x,y);
SD.kernelType = 'tanh';
SD.kernelParam = [p(im),p(jm)];
SM = simpleModelDC(SD,C(km));
SM.train;
[~, perfMin] = SM.test(xt,yt)
figure;
SM.print2D;
clear SM;



%SD2 = simpleData(x,y);
%SD2.kernelType = SD.kernelType;
%SD2.kernelParam = SD.kernelParam;
%SM2 = simpleModelENPSVM(SD2,C,napp);
%SM2.train;
%[ypred perf] = SM2.test(xt,yt);
%perf
%figure;
%SM2.print2D();

