addpath('../');
% test
clear;
close all;
rand('seed',randseed(0))
n = 1000;
d = 2;
x = randn(d,n);
y = ones(n,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = 2;
y(x(1,:)<0) = y(x(1,:)<0)+1;
y(x(2,:)<0) = y(x(2,:)<0)+2;


n = 1000;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1+0.1*randn(1,n)) = 2;
yt(xt(1,:)<0) = yt(xt(1,:)<0)+1;
yt(xt(2,:)<0) = yt(xt(2,:)<0)+2;


figure(1);
color = ['brgkmcy'];
for i=1:max(y)
plot(x(1,y==i),x(2,y==i),['+',color(i)]);
hold on;
end


SD = simpleData(x,y);
SD.kernelType = 'poly';
SD.kernelParam = [5,0.1,0];
Q = max(y);
C = Q/200;
lambda = 1/(2*Q);
%lambda = 0;
SM = simpleModelDocSVM(SD,C,Q,lambda);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D;
[~,pred] = max(ypred,[],2);
CM = confusionMatrix(yt,pred);

% 
% 
% figure;
% C=Q/10;
% SM = simpleModelDocSVM(SD,C,Q,lambda,SM.Il,SM.Iu,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% figure;
% SD.clear();
% SD.kernelParam = 1;
% SM = simpleModelDocSVM(SD,C,Q,lambda,SM.Il,SM.Iu,SM.Iw);
% 
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% tic;
% valErr = SM.crossValError(10)
% toc
% 
% figure;
% C=Q./[100,100,10,1,50];
% SM = simpleModelDocSVM(SD,C,Q,lambda,SM.Il,SM.Iu,SM.Iw);
% 
% tic;
% SM.train;
% toc
% tic;
% [ypred,perf] = SM.test(xt,yt);
% toc
% disp(perf)
% SM.print2D();
% 
% 
% 
% tic;
% valErr = SM.crossValError(10)
% toc
% 
