

addpath('../');
% test
clear all;
close all;

K = load('../Data/lucbrun/kddGramNorm.txt');
S = load('../Data/lucbrun/kddSpectre.txt');
y = load('../Data/lucbrun/kddPred.txt');

n =length(y);
rn = randperm(n);
prop = 1;
app = rn(1:round(prop*n));
tes = rn(round(prop*n)+1:end);
Kapp = K(app,app);
Ktest = K(app,tes);
yapp = y(app);
ytest = y(tes);

%K = exp(K);

SD = simpleData(Kapp,yapp);
%SD.kernelType = 'rbf';
%SD.kernelParam = [1];
SD.kernelType = 'precomputed';
%SD.kernelType = 'poly';
%SD.kernelParam = [3,0.01,1];
C=5;
etube = 0.05;
SM = simpleModelNPSVR(SD,C,etube,40);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test([Kapp;Kapp],yapp);
toc
disp(perf)
% %SM.print2D();
[err,p] = SM.crossValError(prop*n);
err
% 
% figure;
% [ys,s] = sort(ytest);
% plot(ys);
% hold on;
% plot(ypred(s),'r');
% 
% mean(abs(ypred-ytest))
% 
% 
% SD2 = simpleData(Kapp,yapp);
% SD2.kernelType = 'precomputed';
% SM2 = simpleModelSVR(SD2,C,etube);
% tic;
% SM2.train;
% toc
% tic;
% [ypred2,perf] = SM2.test([Ktest],ytest);
% toc
% disp(perf)
% %SM.print2D();
% 
% figure;
% [ys,s] = sort(ytest);
% plot(ys);
% hold on;
% plot(ypred2(s),'r');
% 
% mean(abs(ypred2-ytest))
% 
% 
% %err = SM2.crossValError(10)