
% test
clear all;
close all;
n = 20;
d = 2;
x = [0.3*randn(d,n),0.5*rand(d,n)-[-1;0.5]*ones(1,n),0.3*randn(d,n)+0.2];
y = ones(3*n,1);
%y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = -1;

n = 100;
d = 2;
xt = [0.3*randn(d,n),0.5*rand(d,n)-[-1;0.5]*ones(1,n),0.3*randn(d,n)+0.2,0.4*randn(d,3*n)+0.5];
yt = [ones(3*n,1);-ones(3*n,1)];
%yt(xt(1,:).^2+xt(2,:).^2<1) = -1;
SD = simpleMKLData(x,y);

%A = load('../Data/one_class_training.csv');
% 
%SD = simpleMKLData(A(:,2:6)',A(:,1));


%SD.kernelType = {{'rbf','all'},{'rbf','single'}};
%SD.kernelParam = {10*[0.1 1 5 10],10*[0.1 1 5 10]};


SD.kernelType = {{'rbf','single'},{'rbf','all'}};
SD.kernelParam = {[1],[1]};
nu = 0.05;

SM = simpleMKLModelSVDD(SD,nu); disp(SM.kktgap);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
subplot(1,2,1);
SM.print2D();
plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
title('MKL SVDD');


disp('one class');
nu = 0.005;
SM2 = simpleMKLModelOCSVM(SD,nu);
tic;
SM2.train;
toc
tic;
[ypred,perf] = SM2.test(xt,yt);
toc
disp(perf)
subplot(1,2,2);
SM2.print2D();
plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);

title('MKL OneClass');
