addpath('../');
% test
clear;
close all;
n = 100;
d = 2;
x = [0.2*randn(d,n),0.4*rand(d,n)-0.5,0.3*randn(d,n)+0.1,[1.2;-1]];
y = ones(3*n+1,1);
%y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = -1;

n = 100;
d = 2;
xt = [0.2*randn(d,n),0.4*rand(d,n)-0.5,0.3*randn(d,n)+0.1,0.2*randn(d,3*n)+0.7];
yt = [ones(3*n,1);-ones(3*n,1)];
%yt(xt(1,:).^2+xt(2,:).^2<1) = -1;


figure(1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
figure;


SD = simpleData(x,y);
SD.kernelType = 'rbf';
SD.kernelParam = 2;
nu=0.01;
SM = simpleModelOCSVM(SD,nu);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();
plot(xt(1,yt==1),xt(2,yt==1),'rx');
plot(xt(1,yt==-1),xt(2,yt==-1),'bx');

figure;
nu=0.3;
%SD.clear();
SM = simpleModelOCSVM(SD,nu,SM.Il,SM.Iu,SM.Iw);

tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();
plot(xt(1,yt==1),xt(2,yt==1),'rx');
plot(xt(1,yt==-1),xt(2,yt==-1),'bx');


figure;
SD.clear();
SD.kernelParam = 1;
SM = simpleModelOCSVM(SD,nu,SM.Il,SM.Iu,SM.Iw);

tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();
plot(xt(1,yt==1),xt(2,yt==1),'rx');
plot(xt(1,yt==-1),xt(2,yt==-1),'bx');

% tic;
% valErr = SM.crossValError(10)
% toc
