addpath('../');

clear all;
close all;

load('../data/K_11.mat');
y = [ones(1,200),-ones(1,200)];

SD = simpleData(Kn,y');
C=10000;
SM = simpleModelCSVM(SD,C);
tic;
SM.train;
toc

tic;
[ypred,perf] = SM.test(Kn,y');
toc
disp(perf)

%tic;
%error = SM.crossValError(10)
%toc


% with multiclass
y = [];
for i=1:20
    y = [y;i*ones(20,1)];
end

SD = simpleData(Kn,y);
C=100;
SM = simpleModelCSVM(SD,C);
tic;
SS = SM.train1vs1;
toc

tic;
[ypred,perf] = SM.test1vs1(SS,Kn,y);
toc
disp(perf)


tic;
SS = SM.train1vsAll;
toc

tic;
[ypred,perf] = SM.test1vsAll(SS,Kn,y);
toc
disp(perf)