
addpath('../');
% test
clear all;
close all;
%randn('seed',0)
%rand('seed',0)
n = 200;
d = 2;
x = 4*rand(d,n)-2;
y = ones(n,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = -1;

n = 1000;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1) = -1;

figure(1);
subplot(1,3,1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');

SD = simpleData(x,y);
%SD.kernelType = 'rbf';
%SD.kernelParam = [1];
SD.kernelType = 'tanh';
SD.kernelParam = [0.5,-0.1];
%SD.kernelType = 'poly';
%SD.kernelParam = [3,0.01,1];
SD2 = simpleData(x,y);
SD2.kernelType = 'tanh';
SD2.kernelParam = [0.5,-0.1];

C=1000;
nbEig = 40;

% % decomposer G
% tic;
% SD.getKernelValues(1:SD.n);
% G=SD.kernelCache(1:SD.n,1:SD.n);
% [U,D] = eigs(G,nbEig);
% negs = find(diag(D)<0);
% poss = find(diag(D)>=0);
% 
% Gp = U(:,poss)*D(poss,poss)*U(:,poss)';
% Gn = U(:,negs)*-D(negs,negs)*U(:,negs)';
% 
% % resoudre sur G+
% SD2 = simpleData(Gp,y);
% SM2 = simpleModelCSVMN(SD2,C);
% SM2.train;
% [ypred,perf] = SM2.test(Gp,y);
% disp(perf);
% 
% % resoudre sur G-
% SD3 = simpleData(Gn,y);
% SM3 = simpleModelCSVMN(SD3,C);
% SM3.train;
% [ypred,perf] = SM3.test(Gn,y);
% disp(perf);
% 
% % rassembler les solutions
% alphaF = zeros(size(y));
% alphaF([SM2.Iw,SM2.Iu]) = SM2.alpha/SM2.b;%.*y([SM2.Iw,SM2.Iu]);
% alphaF([SM3.Iw,SM3.Iu]) = alphaF([SM3.Iw,SM3.Iu])-SM3.alpha/SM3.b;%.*y([SM3.Iw,SM3.Iu]);
% %alphaF = alphaF.*y;
% 

SM4 = simpleModelCSVMN(SD,C/2);
tic;
SM4.train;
% SM4.b = 0;%SM3.b;
% SM4.Iw = find(alphaF);
% SM4.alpha = alphaF(SM4.Iw);
% SM4.SV = x(:,SM4.Iw);
toc;
[ypred,perf] = SM4.test(xt,yt);
disp(perf)
figure(1);
subplot(1,3,2);
SM4.print2D();

% comparer avec ENPSVM


subplot(1,3,3);

SM = simpleModelENPSVM(SD2,C,nbEig);
tic;
SM.train;
toc
[ypred,perf] = SM.test(xt,yt);
disp(perf)
SM.print2D();
subplot(1,3,3);
SM.print2D();
